#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#include "consts.h"
#include "function.h"
#include "DataStruct.h"
#include "GS.h"
#include "Point.h"
#include "GSL.h"
#include "Book.h"
#include "Rate.h"

// 3x3p^[𒲂ׂW̒S̑Έʒu
int p3Check[] = {-(DEFAULT_BANSIZE+OOBLNUMx2)-1, -(DEFAULT_BANSIZE+OOBLNUMx2), -(DEFAULT_BANSIZE+OOBLNUMx2)+1, -1, +1, DEFAULT_BANSIZE+OOBLNUMx2-1, DEFAULT_BANSIZE+OOBLNUMx2, DEFAULT_BANSIZE+OOBLNUMx2+1 };

/****************************************
 l
****************************************/
void GSL_initialize(GSL* gsl){
	int i; // [vpϐ

	// GSLlݒ
	gsl->ko = 0;
	gsl->nullID_pointer = 0;
	
	// GSIDݒ
	for(i=0; i<MAXGSNUM; i++){
#if DEBUG
#if PRINT
		if (i < 0 || i >=MAXGSNUM)
			fprintf (stderr, "Iterator error 33 in GSL.c\n");
#endif
#endif
		gsl->stringlist[i].id=INVALID_GSID;
		gsl->nullID[i] = i; // A̖gpIDXg
	}

	return;
}


/****************************************
 GSL̗̈mۂ
****************************************/
GSL* GSL_makeNew(){
	GSL* new_gsl;

	if ((new_gsl = (GSL*)malloc(sizeof(GSL))) == NULL){
		fprintf (stderr, "#malloc() faild 51 in GSL.c");
		getchar();
		exit(1);
	}
	if ((new_gsl->stringlist = (GS*)malloc(MAXGSNUM*sizeof(GS))) == NULL){
		fprintf (stderr, "#malloc() faild 56 in GSL.c()");
		getchar();
		exit(1);
	}
	if ((new_gsl->nullID = (unsigned int*)malloc(MAXGSNUM*sizeof(unsigned int))) == NULL){
		fprintf (stderr, "#malloc() faild 61 in GSL.c()");
		getchar();
		exit(1);
	}
	return new_gsl;
}

/****************************************
 GSLRs[
****************************************/
void GSL_copy(GSL* org_gsl, GSL* new_gsl){
	new_gsl->ko = org_gsl->ko; // RE
	memcpy(new_gsl->stringlist, org_gsl->stringlist, MAXGSNUM*sizeof(GS)); // AXg
	memcpy(new_gsl->nullID, org_gsl->nullID, MAXGSNUM*sizeof(unsigned int)); // nullIDXg
	new_gsl->nullID_pointer = org_gsl->nullID_pointer;

	return;
}

/****************************************
 GSL̍폜
****************************************/
void GSL_delete(GSL* gsl){
	// mallocŊmۂJ
	free(gsl->stringlist); gsl->stringlist = NULL;
	free(gsl->nullID); gsl->nullID = NULL;
	free(gsl); gsl = NULL;

	return;
}


/****************************************
 A폜
****************************************/
void GSL_removeGS(Goban* goban, GS* gs){
	int i, j, k;

	Gsid id;
	Coordinate1d stone; // A̐΂ǂĂϐ
	Coordinate1d tmpxy; // ƗpWi[ϐ

	// oANZX̏ȗ͉
	Point* ptable = goban->ptable; //ƗpPointe[u
	GSL* gsl = goban->gsl; // ƗpGSL
	GS* stringlist = gsl->stringlist; // ƗpGSXg

	
	/*** [begin] AXg̐擪猩Ă ***/
	stone = gs->headstone;
	while(stone>=0){ // AXg̖Ȃ
		// ͂̐΂
		for(i=0; i<ptable[stone].direction_size; i++){
			// ͂̐΂AID𓾂
			tmpxy = ptable[stone].directions[i];
#if DEBUG
#if PRINT
			if (tmpxy < 0 || tmpxy >=GOBAN_ARRAY_SIZE)
				fprintf (stderr, "Iterator error 110 in GSL.c\n");
#endif
#endif
			id = ptable[tmpxy].stringid;
			// AƂ͈ႤAŁAAȂ
			if(id>=0 && (gs->id != id)){
				// 폜ꂽ΂̏ꏊ_ƂĒǉ
				GS_addDame(stone, &stringlist[id]);
			}
		}
#if DEBUG
#if PRINT
		if (stone < 0 || stone >=GOBAN_ARRAY_SIZE)
			fprintf (stderr, "Iterator error 123 in GSL.c\n");
#endif
#endif
		// _ɂ
		ptable[stone].stringid = INVALID_GSID;

		// _ɂ_ƁÂWߖT[gXV
		updateRate(goban, stringlist, stone);
		for (k=0; k<8; k++){
			updateRate(goban, stringlist, stone+p3Check[k]);
		}


#if DEBUG
#if PRINT
		if (stone < 0 || stone >=GOBAN_ARRAY_SIZE)
			fprintf (stderr, "Iterator error 139 in GSL.c\n");
#endif
#endif
		// ̐΂̈ʒu𓾂
		j = ptable[stone].nextstone;
		ptable[stone].nextstone = EOSL; // Ă΂̌q
		stone = j;
	}
	/*** [end] AXg̐擪猩Ă ***/

	// 폜AIDnullIDɃZbg
	GSL_setnullID(goban->gsl, gs->id);
		
	// ÃZbg
	GS_reset(&stringlist[gs->id]);

	return;
}

/****************************************
 WXYɒ肷
 @̏ꍇ́A΂̐Ԃ
 񍇖@̏ꍇ́AΉ萔ijԂ
****************************************/
int GSL_putStone(Goban* goban, Coordinate1d XY, Color color){
	int i, j, k, tmpid, tmpxy; // Ɨp
	int newid; // V쐬AID
	int num_agehama = 0; // ΂̐
	int pos_getishi = OUTER_POS; // ΂̏ꏊiREɂȂ\̂j
	int direction_size; // ͂̔Փ̓_̐
	int* direction_list; // ͂̔Փ̓_̈ʒuXg
	int this_damesize=0 ; // ׂĂ_ɑłꍇ̂̓_iAj̃_TCY
	int eyeid1, eyeid2; // ᔻ ̖̐΂̘AIDƂ
	int suicide_flag = 1; // EtO
	int nige; // ̎ɂȂ邩ǂ̃tO
	int checkflag; // ɒׂAftO
	int checklist[] = {INVALID_GSID,INVALID_GSID,INVALID_GSID,INVALID_GSID}; // ̘͂Ã`FbNXg
	int iCList = 0; // checklist̃Ce[^
	GS* removelist[] = {NULL,NULL,NULL,NULL}; // Aւ̃|C^
	GS* newgs;
	GSL* gsl = goban->gsl;
	GS* stringlist = gsl->stringlist; // ƗpAXg
	Rate* rate = goban->rate; // Ɨp@e[u
	Point* ptable = goban->ptable; // ƗpPointւ̃|C^
	int rn = 0; // Ǎ
	Coordinate1d jikoatari_stack[(int)(DEFAULT_BANSIZE*DEFAULT_BANSIZE/2+0.5)]; // ȃA^n@Ōɂ܂Ƃ߂addVal
	int jk_iterator=0;
	Coordinate1d tori_stack[10]; // @Ōɂ܂Ƃ߂addVal
	int t_iterator=0; // 
	Coordinate1d ate_stack[10]; // Aëʒu
	int a_iterator=0; // 
	Coordinate1d txy, cd1Point;

	// pX
	if (XY == PASS){
		goban->cd1BeforeLastPoint = goban->cd1LastPoint;
		goban->cd1LastPoint = PASS;
		goban->gsl->ko = OOB;
		return 0;
	}

	// ՊOȂ璅łȂ
	if(ptable[XY].direction_size<2){
		return OOB;
	}

	// ɐ΂Ȃ璅łȂ
	if(ptable[XY].stringid >= 0){
		return EXIST;
	}

	// ᔻ菉
	eyeid1 = eyeid2 = INVALID_GSID2;
	nige = 0;

	// ȃANZX
	direction_size = ptable[XY].direction_size;
	direction_list = ptable[XY].directions;

	/*** [begin] @肩iEAREj+𒲂ׂ ***/
	// ͂1ӏׂ
	for(i=0; i<direction_size; i++){
		tmpxy = direction_list[i];
		tmpid = ptable[tmpxy].stringid;
		checkflag = 0; // tO
		// _ł(*)
		if(tmpid < 0){
			// Eł͂ȂAREłȂƂm
			suicide_flag = 0;
			// łȂƂm
			eyeid1 = INVALID_GSID;
			// _ǉ
			this_damesize++;
			continue;
		}

		// ɒׂAł΃XLbv
		for(j=0; j<iCList; j++){
			if(tmpid == checklist[j]){
				checkflag=1;
				break;
			}
		}
		if(checkflag) continue;

		// ̐΂ł
		if(stringlist[tmpid].color == color){
			// ׂĂ_̃_1ł΁AA^瓦ɂȂ邩
			if(stringlist[tmpid].damesize == 1){
				nige = 1;

			}
			//_2ȏ゠
			else if(stringlist[tmpid].damesize > 1){
				// XYɑłĂ_1ȏĉŁAEł͂ȂƂm
				suicide_flag = 0;
			}
			// _Z
			this_damesize += stringlist[tmpid].damesize-1;
			// H
			if (eyeid1 == INVALID_GSID2){
				// AIDۑ
				eyeid1 = tmpid;
			}else if (eyeid2 == INVALID_GSID2){
				// AIDۑ
				eyeid2 = tmpid;
			}
			else if (eyeid1 != tmpid && eyeid2 != tmpid){
				// ۑQƂƘAIDĂΊł͂Ȃ
				eyeid1 = INVALID_GSID;
			}
		}
		// G̐΂ł i_ł邩(*)Ń`FbNς݁j
		else{
			// G̐΂㉺Eǂɂ΁Ał͂Ȃ
			eyeid1 = INVALID_GSID;
			// _1ł
			if(stringlist[tmpid].damesize == 1){
				// ΂
				num_agehama += stringlist[tmpid].size;
				pos_getishi = stringlist[tmpid].headstone;

				// ΂̐1Ȃ
				if(num_agehama == 1){
					// łꏊ́AOɐ΂ꂽꏊȂ
					if(gsl->ko == XY){
						// REȂ̂Œ֎~
						return KO;
					}else{

#if DEBUG
#if PRINT
						if (rn < 0 || rn >= 4)
							fprintf (stderr, "Iterator error 290 in GSL.c\n");
#endif
#endif
						// ܂
						removelist[rn++] = &stringlist[tmpid];
					}
				}
				// 2ȏ̐΂	
				if(num_agehama > 1){

#if DEBUG
#if PRINT
					if (rn < 0 || rn >= 4)
						fprintf (stderr, "Iterator error 303 in GSL.c\n");
#endif
#endif
					// ̂܂܂܂
					removelist[rn++] = &stringlist[tmpid];
					// REɂ͂ȂȂ
					pos_getishi = OUTER_POS;
				}
			}
			// else{} _2ȏ゠΁A΂͎Ȃ
		}

#if DEBUG
#if PRINT
		if (iCList < 0 || iCList >= 4)
			fprintf (stderr, "Iterator error 318 in GSL.c\n");
#endif
#endif
		// ׂAIDL^
		checklist[iCList++] = tmpid;
	}

	// ΂ĂȂAEtOĂ
	if(!num_agehama*suicide_flag){
		// Em
		return SUICIDE;
	}

	// Ȃ̂őłȂ
	// i̎ȂłĂ悢jV`EӁII
	if (eyeid1 != INVALID_GSID && !(nige && this_damesize>=2)){
		return ME;
	}


	/*** [end] @肩iEAREj𒲂ׂ ***/

	/*** [begin] 񏈗 ***/

	// ΂̏ꏊ̋L^
	gsl->ko = pos_getishi;

	// ʒuL^
	goban->cd1BeforeLastPoint = goban->cd1LastPoint;
	goban->cd1LastPoint = XY;

	// A폜A֐ł͍@e[uǉƂ
	for(i=0; i<rn; i++){
		GSL_removeGS(goban, removelist[i]);
	}

	// @e[ũRE֘A͂߂ǂX[

	

	/** [end] @e[u֘A **/

	// [begin] g̘A쐬
	// gpID
	newid = GSL_getnullID(gsl);

	// TCY1̘AƂď
	GS_initialize(stringlist, newid, XY, color);
	// |C^擾
	newgs = &stringlist[newid];
#if DEBUG
#if PRINT
		if (XY < 0 || XY >=GOBAN_ARRAY_SIZE)
			fprintf (stderr, "Iterator error 374 in GSL.c\n");
#endif
#endif
	// IDo^
	ptable[XY].stringid = newid;

	// ͂̓_̃_֘AɂĒׂ
	for(i=0; i<direction_size; i++){
		tmpxy = direction_list[i];
		tmpid = ptable[tmpxy].stringid;
		// _
		if(tmpid < 0){
			Color cl_flag=-2; // F̐΂Ɉ͂܂Ă邩̃tO
			int this_damesize2=0;
			// AɃ_ǉ
			GS_addDame(tmpxy, newgs);
			// ɂ̎͂𒲂ׂ
			for(j=0; j<ptable[tmpxy].direction_size; j++){
				int tmpxy2 = ptable[tmpxy].directions[j];
				// _琔JEg
				if(ptable[tmpxy2].stringid < 0)
					this_damesize2++;
				// ΂F܂łƓ`FbN
				else{
					if (cl_flag==-2)
						cl_flag = stringlist[ptable[tmpxy2].stringid].color;
					// Fbreak `FbNKvȂ
					else if (stringlist[ptable[tmpxy2].stringid].color != cl_flag){
						cl_flag=-1;
						break;
					}
				}
			}
			// _1: ȃA^A܂͂ɑłȂĂĂ΂
			// i_ȊO̐΂݂͂ȓFj
			if (cl_flag >=0 && this_damesize2 == 1){

#if DEBUG
#if PRINT
				if (jk_iterator < 0 || jk_iterator >= (int)(DEFAULT_BANSIZE*DEFAULT_BANSIZE/2+0.5))
					fprintf (stderr, "Iterator error 414 in GSL.c\n");
#endif
#endif				jikoatari_stack[jk_iterator++] = tmpxy;
			}
		}
		// ΂
		else{
			GS* tmpgs = &stringlist[tmpid];
//fprintf(stderr, "(%d, %d)\n", getX(tmpxy), getY(tmpxy));
			// ̐΂̏ꍇ
			// 肵_̓_łȂȂ̂Ŏ菜
			GS_removeDame(XY, tmpgs);
			if(tmpgs->color == newgs->color){
				// ƓAłȂΌ
				if(tmpgs->id != newgs->id){
					// TCY̘̏A傫AɌ
					if (tmpgs->size < newgs->size){
						GSL_setnullID(gsl, tmpgs->id);
						newgs = GS_connectGS(goban, tmpgs, newgs);
					}
					else{
						GSL_setnullID(gsl, newgs->id);
						newgs = GS_connectGS(goban, newgs, tmpgs);
					}
				}
			}
			// G̐΂̏ꍇ
			else{
				int tmpdm, tmpdm2;
				// _2
				if (tmpgs->damesize == 2){
					// Ae̎Ȃ̂Ń_̈ʒuɏd݂
					// _1
					for (k=0; !(tmpgs->dameboard[k]); k++); // rbgĂsT
					tmpdm = tmpgs->dameboard[k] & -tmpgs->dameboard[k]; // E[̃rbĝݕi2̕␔\łƉ)
					tmpdm2 = tmpgs->dameboard[k] ^ tmpdm; // ɃrbgĂ邩Ȃ̂ŕۑ
					tmpdm = (int)(log(tmpdm)/log(2)); // rbgĂʒu͉E牽ԖځH
					tmpdm = getXY(DEFAULT_BANSIZE-tmpdm, k+1); // Տł́i1jW擾
#if DEBUG
#if PRINT
					if (a_iterator < 0 || a_iterator >= 10)
						fprintf (stderr, "Iterator error 457 in GSL.c\n");
#endif
#endif
					ate_stack[a_iterator++] = tmpdm; // Wi[
					// _2
					// sȂ
					if (!tmpdm2){
						for (k++; !(tmpgs->dameboard[k]); k++); // rbgĂsT
						tmpdm2 = tmpgs->dameboard[k];
					}
#if DEBUG
#if PRINT
					if (a_iterator < 0 || a_iterator >= 10)
						fprintf (stderr, "Iterator error 470 in GSL.c\n");
#endif
#endif
					tmpdm2 = (int)(log(tmpdm2)/log(2));
					tmpdm2 = getXY(DEFAULT_BANSIZE-tmpdm2, k+1);
					ate_stack[a_iterator++] = tmpdm2; // Wi[
				}
				// _1ijȂdݕt
				if (tmpgs->damesize == 1){

					// ̎Ȃ̂Ń_̈ʒuɏd݂
					for (k=0; !(tmpgs->dameboard[k]); k++); // _sT
					// ꂪ2Ő^tmpgs->dameboard[k]logvZƁArbgĂʒuE牽Ԗڂ(0,1,2,..18)o
					tmpdm = (int)(log(tmpgs->dameboard[k])/log(2));
					tmpdm = getXY(DEFAULT_BANSIZE-tmpdm, k+1);
#if DEBUG
#if PRINT
					if (t_iterator < 0 || t_iterator >= 10)
						fprintf (stderr, "Iterator error 487 in GSL.c\n");
#endif
#endif
					tori_stack[t_iterator++]=tmpdm; // X^bN
				}
			}
		}
	}

	// [gXV


	// ߋ̒肩̋ɂ郌[eBO
#if 0
	// 9H͑SXV
	for (y=1; y<=DEFAULT_BANSIZE; y++){
		txy = getXY(1, y);
	   	for (x=0; x<DEFAULT_BANSIZE; x++){
			updateRate(goban, stringlist, txy+x);
		}
	}
#else
	// 19H͒̎肾XV
	// 肵
	Rate_setVal(goban->rate, XY, 0);
	// Ƃ8ߖT
	txy = XY + (-(DEFAULT_BANSIZE+OOBLNUMx2)-1);
	if (!isOOB(txy))	updateRate(goban, stringlist, txy);
	txy = txy + 1;
	if (!isOOB(txy))	updateRate(goban, stringlist, txy);
	txy = txy + 1;
	if (!isOOB(txy))	updateRate(goban, stringlist, txy);
	txy = XY - 1;
	if (!isOOB(txy))	updateRate(goban, stringlist, txy);
	txy = XY + 1;
	if (!isOOB(txy))	updateRate(goban, stringlist, txy);
	txy = XY + DEFAULT_BANSIZE+OOBLNUMx2-1;
	if (!isOOB(txy))	updateRate(goban, stringlist, txy);
	txy = txy + 1;
	if (!isOOB(txy))	updateRate(goban, stringlist, txy);
	txy = txy + 1;
	if (!isOOB(txy))	updateRate(goban, stringlist, txy);
	// +4ߖT
	txy = XY + (-(DEFAULT_BANSIZE+DEFAULT_BANSIZE+OOBLNUMx2+OOBLNUMx2));
	if (!isOOB(txy))	updateRate(goban, stringlist, txy);
	txy = XY - 2;
	if (!isOOB(txy))	updateRate(goban, stringlist, txy);
	txy = XY + 2;
	if (!isOOB(txy))	updateRate(goban, stringlist, txy);
	txy = XY + (DEFAULT_BANSIZE+DEFAULT_BANSIZE+OOBLNUMx2+OOBLNUMx2);
	if (!isOOB(txy))	updateRate(goban, stringlist, txy);

	// O̎
	cd1Point = goban->cd1BeforeLastPoint;
	if (!isOOB(cd1Point)) updateRate(goban, stringlist, cd1Point);
	// Ƃ8ߖT
	txy = cd1Point + (-(DEFAULT_BANSIZE+OOBLNUMx2)-1);
	if (!isOOB(txy))	updateRate(goban, stringlist, txy);
	txy = txy + 1;
	if (!isOOB(txy))	updateRate(goban, stringlist, txy);
	txy = txy + 1;
	if (!isOOB(txy))	updateRate(goban, stringlist, txy);
	txy = cd1Point - 1;
	if (!isOOB(txy))	updateRate(goban, stringlist, txy);
	txy = cd1Point + 1;
	if (!isOOB(txy))	updateRate(goban, stringlist, txy);
	txy = cd1Point + DEFAULT_BANSIZE+OOBLNUMx2-1;
	if (!isOOB(txy))	updateRate(goban, stringlist, txy);
	txy = txy + 1;
	if (!isOOB(txy))	updateRate(goban, stringlist, txy);
	txy = txy + 1;
	if (!isOOB(txy))	updateRate(goban, stringlist, txy);
	// +4ߖT
	txy = cd1Point + (-(DEFAULT_BANSIZE+DEFAULT_BANSIZE+OOBLNUMx2+OOBLNUMx2));
	if (!isOOB(txy))	updateRate(goban, stringlist, txy);
	txy = cd1Point - 2;
	if (!isOOB(txy))	updateRate(goban, stringlist, txy);
	txy = cd1Point + 2;
	if (!isOOB(txy))	updateRate(goban, stringlist, txy);
	txy = cd1Point + (DEFAULT_BANSIZE+DEFAULT_BANSIZE+OOBLNUMx2+OOBLNUMx2);
	if (!isOOB(txy))	updateRate(goban, stringlist, txy);
#endif

	// ȃA^n̉lݒ
	for (i=0; i<jk_iterator; i++){
		tmpxy = jikoatari_stack[i];
		Rate_mlpVal(rate, tmpxy, 0.099);
	}

	// ̉l
	for (i=0; i<t_iterator; i++){
		tmpxy = tori_stack[i];
		Rate_mlpVal(rate, tmpxy, 1.78);
	}
	// Aẻl
	for (i=0; i<a_iterator; i++){
		tmpxy = ate_stack[i];
		Rate_mlpVal(rate, tmpxy, 1.73);
	}

	return num_agehama;
}

/****************************************
 WXYɒ肷
 @̏ꍇ́A΂̐Ԃ
 񍇖@̏ꍇ́AΉ萔ijԂ
****************************************/
int GSL_putStonePure(Goban* goban, int XY, int color){
	int i, j, tmpid, tmpxy; // Ɨp
	int newid; // V쐬AID
	int num_agehama = 0; // ΂̐
	int pos_getishi = OUTER_POS; // ΂̏ꏊiREɂȂ\̂j
	int direction_size; // ͂̔Փ̓_̐
	int* direction_list; // ͂̔Փ̓_̈ʒuXg
	int direction; // _̈ʒu
	int suicide_flag = 1; // EtO
	int checkflag; // ɒׂAftO
	int checklist[] = {INVALID_GSID,INVALID_GSID,INVALID_GSID,INVALID_GSID}; // ̘͂Ã`FbNXg
	int iCList = 0; // checklist̃Ce[^
	GS* removelist[] = {NULL,NULL,NULL,NULL}; // Aւ̃|C^
	GS* newgs;
	GSL* gsl = goban->gsl; // ƗpGSL
	GS* stringlist = gsl->stringlist; // ƗpAXg
	Point* ptable = goban->ptable; // ƗpPointւ̃|C^
	Rate* rate = goban->rate;
	int rn = 0; // Ǎ
	Coordinate1d jikoatari_stack[(int)(DEFAULT_BANSIZE*DEFAULT_BANSIZE/2+0.5)]; // ȃA^n@Ōɂ܂Ƃ߂addVal
	int jk_iterator=0;
	Coordinate1d tori_stack[10]; // @Ōɂ܂Ƃ߂addVal
	int t_iterator=0; // 
	Coordinate1d ate_stack[10]; // Aëʒu
	int a_iterator=0; // 
	Coordinate1d txy, cd1Point;

	// pX͏ɍ@
	if (XY == PASS){
		// ʒuL^
		goban->cd1BeforeLastPoint = goban->cd1LastPoint;
		goban->cd1LastPoint = PASS;
		goban->gsl->ko = OOB;
		return 0;
	}

#if DEBUG
	if (XY < 0 || XY >= GOBAN_ARRAY_SIZE){
		return SONOTA;
	}
#endif

	// ՊOȂ璅łȂ
	if(ptable[XY].direction_size<2){
		return OOB;
	}

	// ɐ΂Ȃ璅łȂ
	if(ptable[XY].stringid >= 0){
		return EXIST;
	}
	
	direction_size = ptable[XY].direction_size;
	direction_list = ptable[XY].directions;

	/*** [begin] @肩iEAREj𒲂ׂ ***/
	// ͂1ӏׂ
	for(i=0; i<direction_size; i++){
		direction = direction_list[i];
		tmpid = ptable[direction].stringid;
		checkflag = 0; // tO
		// _ł(*)
		if(tmpid < 0){
			// Eł͂ȂAREłȂƂm
			suicide_flag = 0;
			continue;
		}

		// ɒׂAł΃XLbv
		for(j=0; j<iCList; j++){
			if(tmpid == checklist[j]){
				checkflag=1;
				break;
			}
		}
		if(checkflag) continue;

		// ̐΂ł
		if(stringlist[tmpid].color == color){
			//A_2ȏ゠
			if(stringlist[tmpid].damesize > 1){
				// Eł͂ȂƂm
				suicide_flag = 0;
			}
		}
		// G̐΂ł i_ł邩(*)Ń`FbNς݁j
		else{
			// _1ł
			if(stringlist[tmpid].damesize == 1){
				// ΂
				num_agehama += stringlist[tmpid].size;
				pos_getishi = stringlist[tmpid].headstone;

				// ΂̐1Ȃ
				if(num_agehama == 1){
					// łꏊ́AOɐ΂ꂽꏊȂ
					if(gsl->ko == XY){
						// REȂ̂Œ֎~
						return KO;
					}else{
						// ܂
						removelist[rn++] = &stringlist[tmpid];
					}
				}
				// 2ȏ̐΂	
				if(num_agehama > 1){
#if DEBUG
#if PRINT
					if (rn < 0 || rn >= 4)
						fprintf (stderr, "Iterator error 706 in GSL.c\n");
#endif
#endif
					// ̂܂܂܂
					removelist[rn++] = &stringlist[tmpid];
					// REɂ͂ȂȂ
					pos_getishi = OUTER_POS;
				}
			}
			// else{} _2ȏ゠΁A΂͎Ȃ
		}
#if DEBUG
#if PRINT
		if (iCList < 0 || iCList >= 4)
			fprintf (stderr, "Iterator error 720 in GSL.c\n");
#endif
#endif
		// ׂAIDL^
		checklist[iCList++] = tmpid;
	}

	// ΂ĂȂAEtOĂ
	if(!num_agehama*suicide_flag){
		// Em
		return SUICIDE;
	}

	/*** [end] @肩iEAREj𒲂ׂ ***/

	/*** [begin] 񏈗 ***/

	// ΂̏ꏊ̋L^
	gsl->ko = pos_getishi;

	// ʒuL^
	goban->cd1BeforeLastPoint = goban->cd1LastPoint;
	goban->cd1LastPoint = XY;

	// A폜
	for(i=0; i<rn; i++){
		GSL_removeGS(goban, removelist[i]);
	}

	// [begin] g̘A쐬
	// nullID
	newid = GSL_getnullID(gsl);

	// TCY1̘AƂď
	GS_initialize(stringlist, newid, XY, color);
	// |C^擾
	newgs = &stringlist[newid];
#if DEBUG
#if PRINT
	if (XY < 0 || XY >=GOBAN_ARRAY_SIZE)
		fprintf (stderr, "Iterator error 760 in GSL.c\n");
#endif
#endif
	// IDo^
	ptable[XY].stringid = newid;

	// ͂̓_ɂĒׂ
	for(i=0; i<direction_size; i++){
		tmpxy = ptable[XY].directions[i];
		tmpid = ptable[tmpxy].stringid;

		// Փ̓_
		if(ptable[tmpxy].direction_size<2)
			continue;
		// _
		if(tmpid < 0){
			Color cl_flag=-2; // F̐΂Ɉ͂܂Ă邩̃tO
			int this_damesize2=0;
			int g;
			// AɃ_ǉ
			GS_addDame(tmpxy, newgs);
			for(g=0; g<ptable[tmpxy].direction_size; g++){
				int tmpxy2 = ptable[tmpxy].directions[g];
				// _琔JEg
				if(ptable[tmpxy2].stringid < 0)
					this_damesize2++;
				// ΂F܂łƓ`FbN
				else{
					if (cl_flag==-2)
						cl_flag = stringlist[ptable[tmpxy2].stringid].color;
					// Fbreak `FbNKvȂ
					else if (stringlist[ptable[tmpxy2].stringid].color != cl_flag){
						cl_flag=-1;
						break;
					}
				}
			}
			// _1: ȃA^A܂͂ɑłȂĂĂ΂
			// i_ȊO̐΂݂͂ȓFj
			if (cl_flag >=0 && this_damesize2 == 1){

#if DEBUG
#if PRINT
				if (jk_iterator < 0 || jk_iterator >= (int)(DEFAULT_BANSIZE*DEFAULT_BANSIZE/2+0.5))
					fprintf (stderr, "Iterator error 804 in GSL.c\n");
#endif
#endif
				jikoatari_stack[jk_iterator++] = tmpxy;
			}
		}
		// ΂
		else{
			GS* tmpgs = &stringlist[tmpid];

			// 肵_̓_łȂȂ̂Ŏ菜
			GS_removeDame(XY, tmpgs);
			// ̐΂̏ꍇ
			if(tmpgs->color == newgs->color){
				// ƓAłȂΌ
				if(tmpgs->id != newgs->id){
					// TCY̘̏A傫AɌ
					if (tmpgs->size < newgs->size){
						GSL_setnullID(gsl, tmpgs->id);
						newgs = GS_connectGS(goban, tmpgs, newgs);
					}
					else{
						GSL_setnullID(gsl, newgs->id);
						newgs = GS_connectGS(goban, newgs, tmpgs);
					}
				}
			}
			// G̐΂̏ꍇ
			else{
				int tmpdm, tmpdm2;
				// _2
				if (tmpgs->damesize == 2){
					int g;
					// Ae̎Ȃ̂Ń_̈ʒuɏd݂
					// _1
					for (g=0; !(tmpgs->dameboard[g]); g++); // rbgĂsT
					tmpdm = tmpgs->dameboard[g] & -tmpgs->dameboard[g]; // E[̃rbĝݕi2̕␔\łƉ)
					tmpdm2 = tmpgs->dameboard[g] ^ tmpdm; // ɃrbgĂ邩Ȃ̂ŕۑ
					tmpdm = (int)(log(tmpdm)/log(2)); // rbgĂʒu͉E牽ԖځH
					tmpdm = getXY(DEFAULT_BANSIZE-tmpdm, g+1); // Տł́i1jW擾
#if DEBUG
#if PRINT
					if (a_iterator < 0 || a_iterator >= 10)
						fprintf (stderr, "Iterator error 847 in GSL.c\n");
#endif
#endif
					ate_stack[a_iterator++] = tmpdm; // Wi[
					// _2
					// sȂ
					if (!tmpdm2){
						for (g++; !(tmpgs->dameboard[g]); g++); // rbgĂsT
						tmpdm2 = tmpgs->dameboard[g];
					}
#if DEBUG
#if PRINT
					if (a_iterator < 0 || a_iterator >= 10)
						fprintf (stderr, "Iterator error 860 in GSL.c\n");
#endif
#endif
					tmpdm2 = (int)(log(tmpdm2)/log(2));
					tmpdm2 = getXY(DEFAULT_BANSIZE-tmpdm2, g+1);
					ate_stack[a_iterator++] = tmpdm2; // Wi[
				}
				// _1ijȂdݕt
				if (tmpgs->damesize == 1){
					int g;
					// ̎Ȃ̂Ń_̈ʒuɏd݂
					for (g=0; !(tmpgs->dameboard[g]); g++); // _sT
					// ꂪ2Ő^tmpgs->dameboard[g]logvZƁArbgĂʒuE牽Ԗڂ(0,1,2,..18)o
					tmpdm = (int)(log(tmpgs->dameboard[g])/log(2));
					tmpdm = getXY(DEFAULT_BANSIZE-tmpdm, g+1);
#if DEBUG
#if PRINT
					if (t_iterator < 0 || t_iterator >= 10)
						fprintf (stderr, "Iterator error 878 in GSL.c\n");
#endif
#endif
					tori_stack[t_iterator++]=tmpdm; // X^bN
				}
			}
		}
	}

	// [gXV

	// ߋ̒肩̋ɂ郌[eBO
#if 0
	// 9H͑SXV
	for (y=1; y<=DEFAULT_BANSIZE; y++){
		txy = getXY(1, y);
	   	for (x=0; x<DEFAULT_BANSIZE; x++){
			updateRate(goban, stringlist, txy+x);
		}
	}
#else
	// 19H͒̎肾XV
	// 肵
	Rate_setVal(rate, XY, 0);
	// Ƃ8ߖT
	txy = XY + (-(DEFAULT_BANSIZE+OOBLNUMx2)-1);
	if (!isOOB(txy))	updateRate(goban, stringlist, txy);
	txy = XY + (-(DEFAULT_BANSIZE+OOBLNUMx2));
	if (!isOOB(txy))	updateRate(goban, stringlist, txy);
	txy = XY + (-(DEFAULT_BANSIZE+OOBLNUMx2)+1);
	if (!isOOB(txy))	updateRate(goban, stringlist, txy);
	txy = XY - 1;
	if (!isOOB(txy))	updateRate(goban, stringlist, txy);
	txy = XY + 1;
	if (!isOOB(txy))	updateRate(goban, stringlist, txy);
	txy = XY + DEFAULT_BANSIZE+OOBLNUMx2-1;
	if (!isOOB(txy))	updateRate(goban, stringlist, txy);
	txy = XY + DEFAULT_BANSIZE+OOBLNUMx2;
	if (!isOOB(txy))	updateRate(goban, stringlist, txy);
	txy = XY + DEFAULT_BANSIZE+OOBLNUMx2+1;
	if (!isOOB(txy))	updateRate(goban, stringlist, txy);
	// +4ߖT
	txy = XY + (-(DEFAULT_BANSIZE+DEFAULT_BANSIZE+OOBLNUMx2+OOBLNUMx2));
	if (!isOOB(txy))	updateRate(goban, stringlist, txy);
	txy = XY - 2;
	if (!isOOB(txy))	updateRate(goban, stringlist, txy);
	txy = XY + 2;
	if (!isOOB(txy))	updateRate(goban, stringlist, txy);
	txy = XY + (DEFAULT_BANSIZE+DEFAULT_BANSIZE+OOBLNUMx2+OOBLNUMx2);
	if (!isOOB(txy))	updateRate(goban, stringlist, txy);

	// O̎
	cd1Point = goban->cd1BeforeLastPoint;
	if (!isOOB(cd1Point)) updateRate(goban, stringlist, cd1Point);
	// Ƃ12ߖT
	txy = cd1Point + (-(DEFAULT_BANSIZE+OOBLNUMx2)-1);
	if (!isOOB(txy))	updateRate(goban, stringlist, txy);
	txy = cd1Point + (-(DEFAULT_BANSIZE+OOBLNUMx2));
	if (!isOOB(txy))	updateRate(goban, stringlist, txy);
	txy = cd1Point + (-(DEFAULT_BANSIZE+OOBLNUMx2)+1);
	if (!isOOB(txy))	updateRate(goban, stringlist, txy);
	txy = cd1Point - 1;
	if (!isOOB(txy))	updateRate(goban, stringlist, txy);
	txy = cd1Point + 1;
	if (!isOOB(txy))	updateRate(goban, stringlist, txy);
	txy = cd1Point + DEFAULT_BANSIZE+OOBLNUMx2-1;
	if (!isOOB(txy))	updateRate(goban, stringlist, txy);
	txy = cd1Point + DEFAULT_BANSIZE+OOBLNUMx2;
	if (!isOOB(txy))	updateRate(goban, stringlist, txy);
	txy = cd1Point + DEFAULT_BANSIZE+OOBLNUMx2+1;
	if (!isOOB(txy))	updateRate(goban, stringlist, txy);
	// +4ߖT
	txy = cd1Point + (-(DEFAULT_BANSIZE+DEFAULT_BANSIZE+OOBLNUMx2+OOBLNUMx2));
	if (!isOOB(txy))	updateRate(goban, stringlist, txy);
	txy = cd1Point - 2;
	if (!isOOB(txy))	updateRate(goban, stringlist, txy);
	txy = cd1Point + 2;
	if (!isOOB(txy))	updateRate(goban, stringlist, txy);
	txy = cd1Point + (DEFAULT_BANSIZE+DEFAULT_BANSIZE+OOBLNUMx2+OOBLNUMx2);
	if (!isOOB(txy))	updateRate(goban, stringlist, txy);
#endif

	// ȃA^n̉lݒ
	for (i=0; i<jk_iterator; i++){
		tmpxy = jikoatari_stack[i];
		Rate_mlpVal(rate, tmpxy, 0.099);
	}
	// ̉l
	for (i=0; i<t_iterator; i++){
		tmpxy = tori_stack[i];
		Rate_mlpVal(rate, tmpxy, 1.78);
	}
	// Aẻl
	for (i=0; i<a_iterator; i++){
		tmpxy = ate_stack[i];
		Rate_mlpVal(rate, tmpxy, 1.73);
	}
	return num_agehama;
}

// gpID1Ԃ
Gsid GSL_getnullID(GSL* gsl){
	return gsl->nullID[gsl->nullID_pointer++];
}

// gȂȂIDGSLɕԕi
void GSL_setnullID(GSL* gsl, Gsid id){
	gsl->nullID[--gsl->nullID_pointer] = id;
}
