#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "DataStruct.h"
#include "Rate.h"
#include "UCT.h"
#include "Goban.h"

#define DATANUM_PATTERN3 65536 // 3x3p^[
#define DATANUM_BOARDERDISTANCE 11 // Ւ[̋̃[eBOf[^
#define DATANUM_MOVEDISTANCE 40 // ߋ̒肩̋̃[eBOf[^
#define MCOWNER_LEVEL 8 // MC Owner̒iK

// NeBJeBlɂẴ[gԂ
#define getCriticalityRate(c) (double)(4.0*(c)+0.74)

// [eBOf[^i[ϐ
RateValue g_ratePattern3[DATANUM_PATTERN3]; // 2^16 (1_ɂ2rbg8ߖT)
double g_rateBorderDistance[DATANUM_BOARDERDISTANCE]; // 010
double g_rateMoveDistance1[DATANUM_MOVEDISTANCE]; // O̒肩̋
double g_rateMoveDistance2[DATANUM_MOVEDISTANCE]; // O̒肩̋
double g_rateMCOwner[MCOWNER_LEVEL];


// 3x3p^[̃[eBOf[^t@Cǂݍ
void readRatePattern3x3(){
	FILE* fp;
	char s[256];
	int i;
	double dRateValue;
	char filename[256];

	sprintf_s(filename, 256, "%s%sPattern3.txt", g_rootdir, g_cConsultationMode);
	if (fopen_s(&fp, filename,"r")){
		fprintf(stderr, "#can not open %s\n", filename);
		exit(1);
	}

	// t@Cǂݍ
	i=0;
	while (fgets(s, 256, fp) != NULL){
#if DEBUG
#if PRINT
		if ((strlen(s)-1)<0 || (strlen(s)-1) >= 256)
			fprintf (stderr, "Iterator error 45 in Rate.c\n");
#endif
#endif
		s[strlen(s)-1] = '\0'; // s폜
		dRateValue = atof(s);
#if DEBUG
#if PRINT
		if (i<0 || i >= DATANUM_PATTERN3)
			fprintf (stderr, "Iterator error 53 in Rate.c\n");
#endif
#endif
		g_ratePattern3[i] = (int)(dRateValue*100);
		// [gāA100{Ă1ȏɂȂȂꍇ
		if (!g_ratePattern3[i]){
			g_ratePattern3[i] = 1;
		}
		i++;
	}
	fclose(fp);
}

// Ւ[̋̃[eBOf[^t@Cǂݍ
void readRateBorderDistance(){
	FILE* fp;
	char s[256];
	int i;
	char filename[256];

	sprintf_s(filename, 256, "%sBorderDistance.txt", g_rootdir);
	if (fopen_s(&fp, filename, "r")){
		fprintf(stderr, "#can not open ./BorderDistance.txt\n");
		exit(1);
	}

	// t@Cǂݍ
	i=0;
	while (fgets(s, 256, fp) != NULL){
#if DEBUG
#if PRINT
		if ((strlen(s)-1)<0 || (strlen(s)-1) >= 256)
			fprintf (stderr, "Iterator error 85 in Rate.c\n");
#endif
#endif
		s[strlen(s)-1] = '\0'; // s폜
		g_rateBorderDistance[i] = atof(s);
		i++;
	}
	fclose(fp);
}

// OEO̒肩̋̃[eBOf[^t@Cǂݍ
void readRateMoveDistance(){
	FILE* fp;
	char s[256];
	int i;
	char filename[256];

	sprintf_s(filename, 256, "%sMoveDistance1.txt", g_rootdir);
	// O̒肩̋[eBO
	if (fopen_s(&fp, filename, "r")){
		fprintf(stderr, "#can not open ./MoveDistance1.txt\n");
		exit(1);
	}

	// t@Cǂݍ
	i=0;
	while (fgets(s, 256, fp) != NULL){
#if DEBUG
#if PRINT
		if ((strlen(s)-1)<0 || (strlen(s)-1) >= 256)
			fprintf (stderr, "Iterator error 115 in Rate.c\n");
#endif
#endif
		s[strlen(s)-1] = '\0'; // s폜
#if DEBUG
#if PRINT
		if (i<0 || i >= DATANUM_MOVEDISTANCE)
			fprintf (stderr, "Iterator error 122 in Rate.c\n");
#endif
#endif
		g_rateMoveDistance1[i] = atof(s);
		i++;
	}
	if (i>DATANUM_MOVEDISTANCE){
		fprintf (stderr, "#Iterator error g_rateMoveDistance1 in readMoveDistance()\n");
		exit(1);
	}
	fclose(fp);


	// O̒肩̋[eBO
	sprintf_s(filename, 256, "%sMoveDistance2.txt", g_rootdir);
	if (fopen_s(&fp, filename, "r")){
		fprintf(stderr, "#can not open ./MoveDistance2.txt\n");
		exit(1);
	}

	// t@Cǂݍ
	i=0;
	while (fgets(s, 256, fp) != NULL){
#if DEBUG
#if PRINT
		if ((strlen(s)-1)<0 || (strlen(s)-1) >= 256)
			fprintf (stderr, "Iterator error 148 in Rate.c\n");
#endif
#endif
		s[strlen(s)-1] = '\0'; // s폜
#if DEBUG
#if PRINT
		if (i<0 || i >= DATANUM_MOVEDISTANCE)
			fprintf (stderr, "Iterator error 155 in Rate.c\n");
#endif
#endif
		g_rateMoveDistance2[i] = atof(s);
		i++;
	}
	if (i>DATANUM_MOVEDISTANCE){
		fprintf (stderr, "#Iterator error g_rateMoveDistance2 in readMoveDistance()\n");
		exit(1);
	}
	fclose(fp);
}

// MC Owner̃[gǂݍ
void readRateMCOwner(){
	FILE* fp;
	char s[256];
	int i;
	char filename[256];

	sprintf_s(filename, 256, "%smc_owner.txt", g_rootdir);
	if (fopen_s(&fp, filename, "r")){
		fprintf(stderr, "#can not open ./mc_owner.txt\n");
		exit(1);
	}

	// t@Cǂݍ
	i=0;
	while (fgets(s, 256, fp) != NULL){
#if DEBUG
#if PRINT
		if ((strlen(s)-1)<0 || (strlen(s)-1) >= 256)
			fprintf (stderr, "Iterator error 187 in Rate.c\n");
#endif
#endif
		s[strlen(s)-1] = '\0'; // s폜
#if PRINT
#if DEBUG
		if (i< 0 || i>=MCOWNER_LEVEL)
			fprintf (stderr, "Iterator error 194 in Rate.c\n");
#endif
#endif
		g_rateMCOwner[i] = atof(s);
		i++;
	}
	fclose(fp);
}

// ̈m
Rate* Rate_makeNew(){
	Rate* rate;
	rate = (Rate*)malloc(sizeof(Rate));
	rate->value = (RateValue*)malloc(sizeof(RateValue)*GOBAN_ARRAY_SIZE);
	rate->col_sum = (RateValue*)malloc(sizeof(RateValue)*(DEFAULT_BANSIZE+OOBLNUMx2));
	return rate;
}

// [g
// S̓_ɑ΂updateRategĂ񂾂ǁcȂ񂩂₾
void Rate_initialize(Rate* rate){
	int i, j, k;
	Coordinate1d xy, txy;

	// Ƃ肠SOŏ
	for (i=0; i<GOBAN_ARRAY_SIZE; i++){
#if PRINT
#if DEBUG
		if (i< 0 || i>=GOBAN_ARRAY_SIZE)
			fprintf (stderr, "Iterator error 223 in Rate.c\n");
#endif
#endif
		rate->value[i] ^= rate->value[i];
	}

	// Rg̗͂PXH

	// W(1,1)@
	// 
	// {{
	// {{
	txy = getXY(1,1);
#if PRINT
#if DEBUG
	if (txy< 0 || txy>=GOBAN_ARRAY_SIZE)
		fprintf (stderr, "Iterator error 238 in Rate.c\n");
#endif
#endif
	rate->value[txy] = g_ratePattern3[0xFF30]; // 0b 1111 1111 0011 0000
	rate->value[txy] = (int)((double)rate->value[txy]*g_rateBorderDistance[1]); // 1
	if (!rate->value[txy]) rate->value[txy] = 1;

	// W(2,1)`(18,1)@
	// 
	// {{{
	// {{{
	for (i=2; i<=DEFAULT_BANSIZE-1; i++){
		txy = getXY(i,1);
#if PRINT
#if DEBUG
		if (txy< 0 || txy>=GOBAN_ARRAY_SIZE)
			fprintf (stderr, "Iterator error 252 in Rate.c\n");
#endif
#endif
		rate->value[txy] = g_ratePattern3[0xFC00]; // 0b 1111 1100 0000 0000
		rate->value[txy] = (int)((double)rate->value[txy]*g_rateBorderDistance[1]); // 1
		if (!rate->value[txy]) rate->value[txy] = 1;
	}

	// W(19,1)@E
	// 
	// {{
	// {{
	txy = getXY(DEFAULT_BANSIZE,1);
#if PRINT
#if DEBUG
	if (txy< 0 || txy>=GOBAN_ARRAY_SIZE)
		fprintf (stderr, "Iterator error 266 in Rate.c\n");
#endif
#endif
	rate->value[txy] = g_ratePattern3[0xFCC3]; // 0b 1111 1100 1100 0011
	rate->value[txy] = (int)((double)rate->value[txy]*g_rateBorderDistance[1]); // 1
	if (!rate->value[txy]) rate->value[txy] = 1;

	// W(1,2)`(1,18)@
	// {{
	// {{
	// {{
	for (i=2; i<=DEFAULT_BANSIZE-1; i++){
		txy = getXY(1,i);
#if PRINT
#if DEBUG
		if (txy< 0 || txy>=GOBAN_ARRAY_SIZE)
			fprintf (stderr, "Iterator error 280 in Rate.c\n");
#endif
#endif
		rate->value[txy] = g_ratePattern3[0xC330]; // 0b 1100 0011 0011 0000
		rate->value[txy] = (int)((double)rate->value[txy]*g_rateBorderDistance[1]); // 1
		if (!rate->value[txy]) rate->value[txy] = 1;
	}

	// W(19,2)`(19,18)@E
	// {{
	// {{
	// {{
	for (i=2; i<=DEFAULT_BANSIZE-1; i++){
		txy = getXY(DEFAULT_BANSIZE,i);
#if PRINT
#if DEBUG
		if (txy< 0 || txy>=GOBAN_ARRAY_SIZE)
			fprintf (stderr, "Iterator error 295 in Rate.c\n");
#endif
#endif
		rate->value[txy] = g_ratePattern3[0x0CC3]; // 0b 0000 1100 1100 0011
		rate->value[txy] = (int)((double)rate->value[txy]*g_rateBorderDistance[1]); // 1
		if (!rate->value[txy]) rate->value[txy] = 1;
	}

	// W(2,2)`(18,18)@
	// {{{
	// {{{
	// {{{
	for (i=2; i<=DEFAULT_BANSIZE-1; i++){
		xy = getXY(2,i);
		for (j=0; j<=DEFAULT_BANSIZE-3; j++){
			txy = xy+j;
#if PRINT
#if DEBUG
		if ((txy)< 0 || (txy)>=GOBAN_ARRAY_SIZE)
			fprintf (stderr, "Iterator error 295 in Rate.c\n");
#endif
#endif
			rate->value[txy] = g_ratePattern3[0]; // 0b 0000 0000 0000 0000
			rate->value[txy] = (int)((double)rate->value[txy]*g_rateBorderDistance[getBorderDistanceByXY(txy)]); // قɂ
			if (!rate->value[txy]) rate->value[txy] = 1;
		}
	}

	// W(1,19) 
	// {{
	// {{
	// 
	txy = getXY(1,DEFAULT_BANSIZE);
#if PRINT
#if DEBUG
	if (txy< 0 || txy>=GOBAN_ARRAY_SIZE)
		fprintf (stderr, "Iterator error 327 in Rate.c\n");
#endif
#endif
	rate->value[txy] = g_ratePattern3[0xC33F]; // 0b 1100 0011 0011 1111
	rate->value[txy] = (int)((double)rate->value[txy]*g_rateBorderDistance[1]); // 1
	if (!rate->value[txy]) rate->value[txy] = 1;
	// W(2,19)`(18,19) 
	// {{{
	// {{{
	// 
	for (i=2; i<=DEFAULT_BANSIZE-1; i++){
		txy = getXY(i,DEFAULT_BANSIZE);
#if PRINT
#if DEBUG
		if (txy< 0 || txy>=GOBAN_ARRAY_SIZE)
			fprintf (stderr, "Iterator error 341 in Rate.c\n");
#endif
#endif
		rate->value[txy] = g_ratePattern3[0x003F]; // 0b 0000 0000 0011 1111
		rate->value[txy] = (int)((double)rate->value[txy]*g_rateBorderDistance[1]); // 1
		if (!rate->value[txy]) rate->value[txy] = 1;
	}

	// W(19,19)@E
	// {{
	// {{
	// 
	txy = getXY(DEFAULT_BANSIZE,DEFAULT_BANSIZE);
#if PRINT
#if DEBUG
	if (txy< 0 || txy>=GOBAN_ARRAY_SIZE)
		fprintf (stderr, "Iterator error 355 in Rate.c\n");
#endif
#endif
	rate->value[txy] = g_ratePattern3[0x0CFF]; // 0b 0000 1100 1111 1111
	rate->value[txy] = (int)((double)rate->value[txy]*g_rateBorderDistance[1]); // 1
	if (!rate->value[txy]) rate->value[txy] = 1;
	// d݂̍v
	rate->all_sum = 0;
	for (i=0, k=0; i<DEFAULT_BANSIZE+OOBLNUMx2; i++){
		rate->col_sum[i] = 0;
		for (j=0; j<DEFAULT_BANSIZE+OOBLNUMx2; j++,k++){
			rate->col_sum[i] += rate->value[k];
		}
		rate->all_sum += rate->col_sum[i];
	}
//	showRate(rate);
}

// Ԃ
int getBorderDistanceByXY(Coordinate1d xy){
	Coordinate1d x, y;
	x = getX(xy);
	y = getY(xy);

	// Ւ[̋ɕϊ
	if (x > (DEFAULT_BANSIZE/2+1)){
		x = DEFAULT_BANSIZE+1-x;
	}
	// Ւ[̋ɕϊ
	if (y > (DEFAULT_BANSIZE/2+1)){
		y = DEFAULT_BANSIZE+1-y; //	y = (DEFAULT_BANSIZE+1)-(y-(DEFAULT_BANSIZE+1))
	}

	// 
	if (x<y){
		return x;
	}else{
		return y;
	}
}

// Rs[
void Rate_copy(Rate* org_rate, Rate* new_rate){
	memcpy(new_rate->value, org_rate->value, GOBAN_ARRAY_SIZE*sizeof(RateValue));
	memcpy(new_rate->col_sum, org_rate->col_sum, (DEFAULT_BANSIZE+OOBLNUMx2)*sizeof(RateValue));
	new_rate->all_sum = org_rate->all_sum;
}

// 폜
void Rate_delete(Rate* rate){
	free(rate->value); rate->value = NULL;
	free(rate->col_sum); rate->col_sum = NULL;
	free(rate); rate = NULL;
}

#define PONUM_TO_GET_INFO 63
#define PONUM_TO_GET_INFO_DEVIDED_BY_MCOWNERLEVEL 8
// Ŝ̃[gXV by MC Owner and Criticality
void updateRateByOwnerAndCriticality(Goban* goban){
	RateValue dif; // XVÕ[g
	int iTerritoryOwnedByWinner[GOBAN_ARRAY_SIZE]; // vCAEgɏnƂďLĂ
	int iTerritoryOwnedByBlack[GOBAN_ARRAY_SIZE]; // vCAEgIɍɏLĂ
	int iBlackWinningNumInPO; // vCAEg
	int ponum=PONUM_TO_GET_INFO; // svCAEg
	int iMCO; // MC Owner̃[gz̓Y
	RateValue* rvpRate;
	Coordinate1d xy, txy;
	Coordinate2d x, y;
	double dCriticality;
	Goban* test_goban;

	test_goban = Goban_makeNew();

	memcpy(iTerritoryOwnedByBlack, g_iZeroArray_GOBAN_ARRAY_SIZE, GOBAN_ARRAY_SIZE*sizeof(int));
	memcpy(iTerritoryOwnedByWinner, g_iZeroArray_GOBAN_ARRAY_SIZE, GOBAN_ARRAY_SIZE*sizeof(int));

	// 萔vCAEgs
	iBlackWinningNumInPO ^= iBlackWinningNumInPO;
	while(ponum--){
		Goban_copy(goban, test_goban);
		iBlackWinningNumInPO += getValueByMC(test_goban, BLACK, &judgeToGetInfo, &judge_sekiToGetInfo, iTerritoryOwnedByWinner, iTerritoryOwnedByBlack);
	}

	// ՑŜ̃[gMC OwnerCriticalityɂčXV
	for (y=1; y<=DEFAULT_BANSIZE; y++){
		txy = getXY(1, y);
		for (x=0; x<DEFAULT_BANSIZE; x++){
			xy = txy + x;
			dif = goban->rate->value[xy];
			rvpRate = &goban->rate->value[xy];

#if DEBUG
#if PRINT
			if (iTerritoryOwnedByBlack[xy] < 0 || iTerritoryOwnedByBlack[xy] > 63)
				fprintf (stderr, "#error 448 in Rate.c\n");
			if (iTerritoryOwnedByWinner[xy] < 0 || iTerritoryOwnedByWinner[xy] > 63)
				fprintf (stderr, "#error 450 in Rate.c\n");
#endif
#endif

			// MC Owner
			// ԁF
			//////////////////////////////////////////////////////////////////////
			// for̒if̂邹Ȃ[
			// goban->turncolorŊ|ZƂĂȂƂłHxrKv
			//////////////////////////////////////////////////////////////////////
//			if (goban->turncolor==WHITE){
//				iMCO = (PONUM_TO_GET_INFO-iTerritoryOwnedByBlack[xy])/PONUM_TO_GET_INFO_DEVIDED_BY_MCOWNERLEVEL;
//			}else{
//				iMCO = iTerritoryOwnedByBlack[xy]/PONUM_TO_GET_INFO_DEVIDED_BY_MCOWNERLEVEL;
//			}
//			
			iMCO = ((goban->turncolor*PONUM_TO_GET_INFO)+(-1*goban->turncolor)*iTerritoryOwnedByBlack[xy])/PONUM_TO_GET_INFO_DEVIDED_BY_MCOWNERLEVEL;

			// Criticality
			//if (goban->turncolor==BLACK)
			//	dCriticality = (double)(iTerritoryOwnedByWinner[xy]-PONUM_TO_GET_INFO+iMyWinningNumInPO+iTerritoryOwnedByBlack[xy])/(double)PONUM_TO_GET_INFO;
			//// (iTerritoryOwnedByWinner[xy]/PONUM_TO_GET_INFO
			//// -((PONUM_TO_GET_INFO-iTerritoryOwnedByBlack[xy])*(PONUM_TO_GET_INFO-iMyWinningNumInPO)
			//// +(iTerritoryOwnedByBlack[xy]*iMyWinningNumInPO))/(PONUM_TO_GET_INFO*PONUM_TO_GET_INFO);
			//else
			//	dCriticality = (double)(iTerritoryOwnedByWinner[xy]-iMyWinningNumInPO+iTerritoryOwnedByBlack[xy])/(double)PONUM_TO_GET_INFO
			//	+(double)(iTerritoryOwnedByBlack[xy]+iMyWinningNumInPO+iTerritoryOwnedByBlack[xy]+iMyWinningNumInPO)/((double)(PONUM_TO_GET_INFO)*(double)(PONUM_TO_GET_INFO));
			//// (iTerritoryOwnedByWinner[xy]/PONUM_TO_GET_INFO
			//// -((PONUM_TO_GET_INFO-iTerritoryOwnedByBlack[xy])*iMyWinningNumInPO
			//// +(iTerritoryOwnedByBlack[xy]*(PONUM_TO_GET_INFO-iMyWinningNumInPO)))/(PONUM_TO_GET_INFO*PONUM_TO_GET_INFO);
			//// Ō̃vCAEgQ̓I[o[t[΍̂߂ɃLXgZ

			dCriticality = ((double)iTerritoryOwnedByWinner[xy]/(double)PONUM_TO_GET_INFO)
				- (
				 ((double)(PONUM_TO_GET_INFO-iTerritoryOwnedByBlack[xy])/(double)PONUM_TO_GET_INFO)
				 *((double)(PONUM_TO_GET_INFO-iBlackWinningNumInPO)/(double)PONUM_TO_GET_INFO)
				)
				+ (
				 ((double)iTerritoryOwnedByBlack[xy]/(double)PONUM_TO_GET_INFO)
				 *((double)iBlackWinningNumInPO/(double)PONUM_TO_GET_INFO)
				);

			if (dCriticality < 0.0)
				dCriticality = 0.0;
			else if (dCriticality > 0.440)
				dCriticality = 0.440;

			// [g
#if DEBUG
#if PRINT
			if (iMCO > MCOWNER_LEVEL || iMCO < 0){
				fprintf (stderr, "#Illegal iterator: variable \"iMCO\" (%d) in updateRateByOwnerAndCriticality()\n", iMCO);
				fflush(stderr);
				getchar();
			}
			else{
#endif
#endif
				*rvpRate = (int)((double)(*rvpRate)
					* g_rateMCOwner[iMCO] // MC Owner̃[g
				* getCriticalityRate(dCriticality) // Criticalitỹ[g
					);
#if DEBUG
#if PRINT
			}
#endif
#endif

			// lintƂ0ɂȂȂAŒ̃[g͗^
			if (!(*rvpRate)){
				*rvpRate = 1;
			}

			// [gvlXV
			dif = *rvpRate - dif; // [g
#if PRINT
#if DEBUG
		if ((getY(xy)+OOBLNUM-1)< 0 || (getY(xy)+OOBLNUM-1)>=DEFAULT_BANSIZE+OOBLNUMx2)
			fprintf (stderr, "Iterator error 515 in Rate.c\n");
#endif
#endif
			goban->rate->col_sum[getY(xy)+OOBLNUM-1] += dif;
			goban->rate->all_sum += dif;
		}
	}

	Goban_delete(test_goban);
}


/* 3x3p^[
̐ɊÂĂɂ傲ɂĂ邩A
őȂƂł͕ύXȂƁI
ύXƂupdateRate()悭mF邱ƁB
*/
#define EMP3x3 0 // 0b00
#define BLK3x3 1 // 0b01
#define WHT3x3 2 // 0b10
#define OOB3x3 3 // 0b11

// w肵W̃[gXV
// ŷ̂̂
// E3x3p^[
// EՒ[̋
void updateRate(Goban* goban, GS* stringlist, Coordinate1d xy){
	int pattern=0;
	RateValue dif; // XVÕ[g
	Coordinate1d xy1, xy2, xy3, xy4, xy5, xy6, xy7, xy8; // ׂW
	// AhbVO
	Point* ptable = goban->ptable;
	RateValue* rvpRate;

	// XVÕ[gۑ
	dif = goban->rate->value[xy];
	rvpRate = &goban->rate->value[xy];

#if PRINT
#if DEBUG
		if (xy< 0 || xy>=GOBAN_ARRAY_SIZE)
			fprintf (stderr, "Iterator error 556 in Rate.c\n");
#endif
#endif
	// ɐ΂Ȃ烌[g0
	if (ptable[xy].stringid != INVALID_GSID){
		*rvpRate = 0;
	}
	// ՊOȂXVȂ
	else if (isOOB(xy)){
		return;
	}
	// _Ȃp^[
	else{
		Coordinate1d dx1, dy1, dx2, dy2;
		unsigned int distance1, distance2;

		// CforWJI

		// 8ߖT1W
		xy1 = xy + (-(DEFAULT_BANSIZE+OOBLNUMx2)-1);
		xy2 = xy + (-(DEFAULT_BANSIZE+OOBLNUMx2));
		xy3 = xy + (-(DEFAULT_BANSIZE+OOBLNUMx2)+1);
		xy4 = xy - 1;
		xy5 = xy + 1;
		xy6 = xy + DEFAULT_BANSIZE+OOBLNUMx2-1;
		xy7 = xy + DEFAULT_BANSIZE+OOBLNUMx2;
		xy8 = xy + DEFAULT_BANSIZE+OOBLNUMx2+1;

		// 1 2 3
		// 4 + 5
		// 6 7 8

#if PRINT
#if DEBUG
		if (xy1< 0 || xy1>=GOBAN_ARRAY_SIZE)
			fprintf (stderr, "Iterator error 776 in Rate.c\n");
		if (xy2< 0 || xy2>=GOBAN_ARRAY_SIZE)
			fprintf (stderr, "Iterator error 778 in Rate.c\n");
		if (xy3< 0 || xy3>=GOBAN_ARRAY_SIZE)
			fprintf (stderr, "Iterator error 780 in Rate.c\n");
		if (xy4< 0 || xy4>=GOBAN_ARRAY_SIZE)
			fprintf (stderr, "Iterator error 782 in Rate.c\n");
		if (xy5< 0 || xy5>=GOBAN_ARRAY_SIZE)
			fprintf (stderr, "Iterator error 784 in Rate.c\n");
		if (xy6< 0 || xy6>=GOBAN_ARRAY_SIZE)
			fprintf (stderr, "Iterator error 786 in Rate.c\n");
		if (xy7< 0 || xy7>=GOBAN_ARRAY_SIZE)
			fprintf (stderr, "Iterator error 788 in Rate.c\n");
		if (xy8< 0 || xy8>=GOBAN_ARRAY_SIZE)
			fprintf (stderr, "Iterator error 790 in Rate.c\n");
		if (ptable[xy1].stringid < -1 || ptable[xy1].stringid >= MAXGSNUM)
			fprintf (stderr, "Iterator error 792 in Rate.c\n");
		if (ptable[xy2].stringid < -1 || ptable[xy2].stringid >= MAXGSNUM)
			fprintf (stderr, "Iterator error 794 in Rate.c\n");
		if (ptable[xy3].stringid < -1 || ptable[xy3].stringid >= MAXGSNUM)
			fprintf (stderr, "Iterator error 796 in Rate.c\n");
		if (ptable[xy4].stringid < -1 || ptable[xy4].stringid >= MAXGSNUM)
			fprintf (stderr, "Iterator error 798 in Rate.c\n");
		if (ptable[xy5].stringid < -1 || ptable[xy5].stringid >= MAXGSNUM)
			fprintf (stderr, "Iterator error 800 in Rate.c\n");
		if (ptable[xy6].stringid < -1 || ptable[xy6].stringid >= MAXGSNUM)
			fprintf (stderr, "Iterator error 802 in Rate.c\n");
		if (ptable[xy7].stringid < -1 || ptable[xy7].stringid >= MAXGSNUM)
			fprintf (stderr, "Iterator error 804 in Rate.c\n");
		if (ptable[xy8].stringid < -1 || ptable[xy8].stringid >= MAXGSNUM)
			fprintf (stderr, "Iterator error 806 in Rate.c\n");
		if (ptable[xy1].stringid >= 0 && (stringlist[ptable[xy1].stringid].color < 0 || stringlist[ptable[xy1].stringid].color > 1))
			fprintf (stderr, "Iterator error 808 in Rate.c\n");
		if (ptable[xy2].stringid >= 0 && (stringlist[ptable[xy2].stringid].color < 0 || stringlist[ptable[xy2].stringid].color > 1))
			fprintf (stderr, "Iterator error 810 in Rate.c\n");
		if (ptable[xy3].stringid >= 0 && (stringlist[ptable[xy3].stringid].color < 0 || stringlist[ptable[xy3].stringid].color > 1))
			fprintf (stderr, "Iterator error 812 in Rate.c\n");
		if (ptable[xy4].stringid >= 0 && (stringlist[ptable[xy4].stringid].color < 0 || stringlist[ptable[xy4].stringid].color > 1))
			fprintf (stderr, "Iterator error 814 in Rate.c\n");
		if (ptable[xy5].stringid >= 0 && (stringlist[ptable[xy5].stringid].color < 0 || stringlist[ptable[xy5].stringid].color > 1))
			fprintf (stderr, "Iterator error 816 in Rate.c\n");
		if (ptable[xy6].stringid >= 0 && (stringlist[ptable[xy6].stringid].color < 0 || stringlist[ptable[xy6].stringid].color > 1))
			fprintf (stderr, "Iterator error 818 in Rate.c\n");
		if (ptable[xy7].stringid >= 0 && (stringlist[ptable[xy7].stringid].color < 0 || stringlist[ptable[xy7].stringid].color > 1))
			fprintf (stderr, "Iterator error 820 in Rate.c\n");
		if (ptable[xy8].stringid >= 0 && (stringlist[ptable[xy8].stringid].color < 0 || stringlist[ptable[xy8].stringid].color > 1))
			fprintf (stderr, "Iterator error 822 in Rate.c\n");
#endif
#endif
		// p^[l
		if (ptable[xy1].direction_size >= 2){	// 1Փ?
			if (ptable[xy8].direction_size >= 2){	// 8Փ?
				// {{{
				// {{{
				// {{{
				// (΂Ȃꍇ́A_\0Ȃ̂ŉȂ)
				if (ptable[xy1].stringid != INVALID_GSID)
					pattern |= (stringlist[ptable[xy1].stringid].color + 1) << 14;
				if (ptable[xy2].stringid != INVALID_GSID)
					pattern |= (stringlist[ptable[xy2].stringid].color + 1) << 12;
				if (ptable[xy3].stringid != INVALID_GSID)
					pattern |= (stringlist[ptable[xy3].stringid].color + 1) << 10;
				if (ptable[xy4].stringid != INVALID_GSID)
					pattern |= (stringlist[ptable[xy4].stringid].color + 1) << 8;
				if (ptable[xy5].stringid != INVALID_GSID)
					pattern |= (stringlist[ptable[xy5].stringid].color + 1) << 6;
				if (ptable[xy6].stringid != INVALID_GSID)
					pattern |= (stringlist[ptable[xy6].stringid].color + 1) << 4;
				if (ptable[xy7].stringid != INVALID_GSID)
					pattern |= (stringlist[ptable[xy7].stringid].color + 1) << 2;
				if (ptable[xy8].stringid != INVALID_GSID)
					pattern |= (stringlist[ptable[xy8].stringid].color + 1);
			}
			else if (ptable[xy3].direction_size >= 2){	// 3Փ?
				// {{{
				// {{{ Ւ[
				//  ՊO
				if (ptable[xy1].stringid != INVALID_GSID)
					pattern |= (stringlist[ptable[xy1].stringid].color + 1) << 14;
				if (ptable[xy2].stringid != INVALID_GSID)
					pattern |= (stringlist[ptable[xy2].stringid].color + 1) << 12;
				if (ptable[xy3].stringid != INVALID_GSID)
					pattern |= (stringlist[ptable[xy3].stringid].color + 1) << 10;
				if (ptable[xy4].stringid != INVALID_GSID)
					pattern |= (stringlist[ptable[xy4].stringid].color + 1) << 8;
				if (ptable[xy5].stringid != INVALID_GSID)
					pattern |= (stringlist[ptable[xy5].stringid].color + 1) << 6;
				// pattern |= OOB3x3 << 4;
				// pattern |= OOB3x3 << 2;
				// pattern |= OOB3x3;
				// 
				pattern |= 63;
			}
			else if (ptable[xy6].direction_size >= 2){	// 6Փ?
				// {{
				// {{
				// {{
				if (ptable[xy1].stringid != INVALID_GSID)
					pattern |= (stringlist[ptable[xy1].stringid].color + 1) << 14;
				if (ptable[xy2].stringid != INVALID_GSID)
					pattern |= (stringlist[ptable[xy2].stringid].color + 1) << 12;
				if (ptable[xy4].stringid != INVALID_GSID)
					pattern |= (stringlist[ptable[xy4].stringid].color + 1) << 8;
				if (ptable[xy6].stringid != INVALID_GSID)
					pattern |= (stringlist[ptable[xy6].stringid].color + 1) << 4;
				if (ptable[xy7].stringid != INVALID_GSID)
					pattern |= (stringlist[ptable[xy7].stringid].color + 1) << 2;
				// pattern |= OOB3x3 << 10;
				// pattern |= OOB3x3 << 6;
				// pattern |= OOB3x3;
				// 
				pattern |= 3267;
			}
			else{
				// {{
				// {{
				// 
				if (ptable[xy1].stringid != INVALID_GSID)
					pattern |= (stringlist[ptable[xy1].stringid].color + 1) << 14;
				if (ptable[xy2].stringid != INVALID_GSID)
					pattern |= (stringlist[ptable[xy2].stringid].color + 1) << 12;
				if (ptable[xy4].stringid != INVALID_GSID)
					pattern |= (stringlist[ptable[xy4].stringid].color + 1) << 8;
				// pattern |= OOB3x3 << 10;
				// pattern |= OOB3x3 << 6;
				// pattern |= OOB3x3 << 4;
				// pattern |= OOB3x3 << 2;
				// pattern |= OOB3x3;
				// 
				pattern |= 3327;
			}
		}
		else if (ptable[xy3].direction_size >= 2){	// 3Փ?
			if (ptable[xy8].direction_size >= 2){	// 8Փ?
				// {{
				// {{
				// {{
				if (ptable[xy2].stringid != INVALID_GSID)
					pattern |= (stringlist[ptable[xy2].stringid].color + 1) << 12;
				if (ptable[xy3].stringid != INVALID_GSID)
					pattern |= (stringlist[ptable[xy3].stringid].color + 1) << 10;
				if (ptable[xy5].stringid != INVALID_GSID)
					pattern |= (stringlist[ptable[xy5].stringid].color + 1) << 6;
				if (ptable[xy7].stringid != INVALID_GSID)
					pattern |= (stringlist[ptable[xy7].stringid].color + 1) << 2;
				if (ptable[xy8].stringid != INVALID_GSID)
					pattern |= (stringlist[ptable[xy8].stringid].color + 1);
				// pattern |= OOB3x3 << 14;
				// pattern |= OOB3x3 << 8;
				// pattern |= OOB3x3 << 4;
				// 
				pattern |= 49968;
			}
			else{
				// {{
				// {{
				// 
				if (ptable[xy2].stringid != INVALID_GSID)
					pattern |= (stringlist[ptable[xy2].stringid].color + 1) << 12;
				if (ptable[xy3].stringid != INVALID_GSID)
					pattern |= (stringlist[ptable[xy3].stringid].color + 1) << 10;
				if (ptable[xy5].stringid != INVALID_GSID)
					pattern |= (stringlist[ptable[xy5].stringid].color + 1) << 6;
				// pattern |= OOB3x3 << 14;
				// pattern |= OOB3x3 << 8;
				// pattern |= OOB3x3 << 4;
				// pattern |= OOB3x3 << 2;
				// pattern |= OOB3x3;
				// 
				pattern |= 49983;
			}
		}
		else if (ptable[xy6].direction_size >= 2){	// 6Փ?
			if (ptable[xy8].direction_size >= 2){	// 8Փ?
				// 
				// {{{
				// {{{
				if (ptable[xy4].stringid != INVALID_GSID)
					pattern |= (stringlist[ptable[xy4].stringid].color + 1) << 8;
				if (ptable[xy5].stringid != INVALID_GSID)
					pattern |= (stringlist[ptable[xy5].stringid].color + 1) << 6;
				if (ptable[xy6].stringid != INVALID_GSID)
					pattern |= (stringlist[ptable[xy6].stringid].color + 1) << 4;
				if (ptable[xy7].stringid != INVALID_GSID)
					pattern |= (stringlist[ptable[xy7].stringid].color + 1) << 2;
				if (ptable[xy8].stringid != INVALID_GSID)
					pattern |= (stringlist[ptable[xy8].stringid].color + 1);
				// pattern |= OOB3x3 << 14;
				// pattern |= OOB3x3 << 12;
				// pattern |= OOB3x3 << 10;
				// 
				pattern |= 64512;
			}else{
				// 
				// {{
				// {{
				if (ptable[xy4].stringid != INVALID_GSID)
					pattern |= (stringlist[ptable[xy4].stringid].color + 1) << 8;
				if (ptable[xy6].stringid != INVALID_GSID)
					pattern |= (stringlist[ptable[xy6].stringid].color + 1) << 4;
				if (ptable[xy7].stringid != INVALID_GSID)
					pattern |= (stringlist[ptable[xy7].stringid].color + 1) << 2;
				// pattern |= OOB3x3 << 14;
				// pattern |= OOB3x3 << 12;
				// pattern |= OOB3x3 << 10;
				// pattern |= OOB3x3 << 6;
				// pattern |= OOB3x3;
				// 
				pattern |= 64707;
			}
		}
		else{
			// 
			// {{
			// {{
			if (ptable[xy5].stringid != INVALID_GSID)
				pattern |= (stringlist[ptable[xy5].stringid].color + 1) << 6;
			if (ptable[xy7].stringid != INVALID_GSID)
				pattern |= (stringlist[ptable[xy7].stringid].color + 1) << 2;
			if (ptable[xy8].stringid != INVALID_GSID)
				pattern |= (stringlist[ptable[xy8].stringid].color + 1);
			// pattern |= OOB3x3 << 14;
			// pattern |= OOB3x3 << 12;
			// pattern |= OOB3x3 << 10;
			// pattern |= OOB3x3 << 8;
			// pattern |= OOB3x3 << 4;
			// 
			pattern |= 65328;
		}


/*
		if (ptable[xy1].stringid < 0) // ΂Ȃ
			if (ptable[xy1].direction_size >= 2)	// _
				pattern |= EMP3x3 << 14;
			else pattern |= OOB3x3 << 14;			// ՊO
		else
			pattern |= (stringlist[ptable[xy1].stringid].color + 1) << 14;

		if (ptable[xy2].stringid < 0) // ΂Ȃ
			if (ptable[xy2].direction_size >= 2)	// _
				pattern |= EMP3x3 << 12;
			else pattern |= OOB3x3 << 12;			// ՊO
		else
			pattern |= (stringlist[ptable[xy2].stringid].color + 1) << 12;

		if (ptable[xy3].stringid < 0) // ΂Ȃ
			if (ptable[xy3].direction_size >= 2)	// _
				pattern |= EMP3x3 << 10;
			else pattern |= OOB3x3 << 10;			// ՊO
		else
			pattern |= (stringlist[ptable[xy3].stringid].color + 1) << 10;

		if (ptable[xy4].stringid < 0) // ΂Ȃ
			if (ptable[xy4].direction_size >= 2)	// _
				pattern |= EMP3x3 << 8;
			else pattern |= OOB3x3 << 8;		// ՊO
		else
			pattern |= (stringlist[ptable[xy4].stringid].color + 1) << 8;

		if (ptable[xy5].stringid < 0) // ΂Ȃ
			if (ptable[xy5].direction_size >= 2)	// _
				pattern |= EMP3x3 << 6;
			else pattern |= OOB3x3 << 6;			// ՊO
		else
			pattern |= (stringlist[ptable[xy5].stringid].color + 1) << 6;

		if (ptable[xy6].stringid < 0) // ΂Ȃ
			if (ptable[xy6].direction_size >= 2)	// _
				pattern |= EMP3x3 << 4;
			else pattern |= OOB3x3 << 4;			// ՊO
		else
			pattern |= (stringlist[ptable[xy6].stringid].color + 1) << 4;

		if (ptable[xy7].stringid < 0) // ΂Ȃ
			if (ptable[xy7].direction_size >= 2)	// _
				pattern |= EMP3x3 << 2;
			else pattern |= OOB3x3 << 2;			// ՊO
		else
			pattern |= (stringlist[ptable[xy7].stringid].color + 1) << 2;

		if (ptable[xy8].stringid < 0) // ΂Ȃ
			if (ptable[xy8].direction_size >= 2)	// _
				pattern |= EMP3x3;
			else pattern |= OOB3x3; 			// ՊO
		else
			pattern |= (stringlist[ptable[xy8].stringid].color + 1);
*/
#if PRINT
#if DEBUG
		if (pattern< 0 || pattern>=DATANUM_PATTERN3)
			fprintf (stderr, "Iterator error 852 in Rate.c\n");
#endif
#endif
		// Ƃp^[Ń[gZbg
		*rvpRate = g_ratePattern3[pattern];

		// Ւ[̋Aߋ̒肩̋Ń[g|
		// Ő
		if ((goban->cd1LastPoint != OOB) && (goban->cd1LastPoint != PASS)){
			dx1 = abs(getX(goban->cd1LastPoint) - getX(xy));
			dy1 = abs(getY(goban->cd1LastPoint) - getY(xy));
			distance1 = dx1 + dy1 + dx1*(dx1>=dy1) + dy1*(dx1<dy1); // dx + dy + max(dx, dy)
		}
		else{
			distance1 = 1; // Y1:[g1.0
		}
		// Ő
		if ((goban->cd1BeforeLastPoint != OOB) && (goban->cd1BeforeLastPoint != PASS)){
			dx2 = abs(getX(goban->cd1BeforeLastPoint) - getX(xy));
			dy2 = abs(getY(goban->cd1BeforeLastPoint) - getY(xy));
			distance2 = dx2 + dy2 + dx2*(dx2>=dy2) + dy2*(dx2<dy2); // dx + dy + max(dx, dy)
		}
		else{
			distance2 = 1; // Y1:[g1.0
		}

#if PRINT
#if DEBUG
		if (getBorderDistanceByXY(xy)< 0 ||getBorderDistanceByXY(xy) > DATANUM_BOARDERDISTANCE)
			fprintf (stderr, "error 881 in Rate.c\n");
		if (distance1< 0 || distance1>= DATANUM_MOVEDISTANCE)
			fprintf (stderr, "error 883 in Rate.c\n");
		if (distance2< 0 || distance2>= DATANUM_MOVEDISTANCE)
			fprintf (stderr, "error 885 in Rate.c\n");
#endif
#endif
		// [g
		*rvpRate = (RateValue)(*rvpRate
			* g_rateBorderDistance[getBorderDistanceByXY(xy)] // Ւ[̋[g
		* g_rateMoveDistance1[distance1] // Ő[g
		* g_rateMoveDistance2[distance2] // Ő[g
		);

		// lintƂ0ɂȂȂAŒ̃[g͗^
		if (!*rvpRate){
			*rvpRate = 1;
		}
		if (*rvpRate<0){
			*rvpRate = 100000;
		}
	}

#if PRINT
#if DEBUG
	if (getY(xy)+OOBLNUM-1< 0 || getY(xy)+OOBLNUM-1 >= DEFAULT_BANSIZE+OOBLNUMx2)
		fprintf (stderr, "Itrator error 904 in Rate.c\n");
#endif
#endif
	// [gvlXV
	dif = (*rvpRate) - dif; // [g
	goban->rate->col_sum[getY(xy)+OOBLNUM-1] += dif;
	goban->rate->all_sum += dif;
}

// |CgXỶlval
void Rate_mlpVal(Rate* rate, Coordinate1d XY, double val){
	RateValue dif;
	if (isOOB(XY)){
		return;
	}
	dif = rate->value[XY];

#if PRINT
#if DEBUG
	if (XY< 0 || XY>=GOBAN_ARRAY_SIZE)
		fprintf (stderr, "Iterator error 924 in Rate.c\n");
	if (getY(XY)+OOBLNUM-1< 0 || getY(XY)+OOBLNUM-1 >= DEFAULT_BANSIZE+OOBLNUMx2)
		fprintf (stderr, "Itrator error 932 in Rate.c\n");
#endif
#endif
	rate->value[XY] = (int)(rate->value[XY]*val);
	if (!rate->value[XY]){
		rate->value[XY] = 1;
	}
	else if (rate->value[XY]<0){
		rate->value[XY] = 100000;
	}
	dif = rate->value[XY] - dif;
	rate->col_sum[getY(XY)+OOBLNUM-1] += dif;
	rate->all_sum += dif;

	return;
}

// |CgXYɉlǉ
// value: ̉lBǂł
void Rate_addVal(Rate* rate, Coordinate1d XY, RateValue val){
	if (isOOB(XY)){
		return;
	}
#if PRINT
#if DEBUG
	if (XY< 0 || XY>=GOBAN_ARRAY_SIZE)
		fprintf (stderr, "Iterator error 950 in Rate.c\n");
	if (getY(XY)+OOBLNUM-1< 0 || getY(XY)+OOBLNUM-1 >= DEFAULT_BANSIZE+OOBLNUMx2)
		fprintf (stderr, "Itrator error 957 in Rate.c\n");
#endif
#endif
	rate->value[XY] += val;
	rate->col_sum[getY(XY)+OOBLNUM-1] += val;
	rate->all_sum += val;

	return;
}

// |Cgɉlݒ
// value: ,ǂł
void Rate_setVal(Rate* rate, Coordinate1d XY, RateValue val){
	if (isOOB(XY)){
		return;
	}
#if PRINT
#if DEBUG
	if (getY(XY)+OOBLNUM-1< 0 || getY(XY)+OOBLNUM-1 >= DEFAULT_BANSIZE+OOBLNUMx2)
		fprintf (stderr, "Itrator error 975 in Rate.c\n");
	if (XY< 0 || XY>=GOBAN_ARRAY_SIZE)
		fprintf (stderr, "Iterator error 983 in Rate.c\n");
#endif
#endif
	rate->col_sum[getY(XY)+OOBLNUM-1] -= rate->value[XY]-val;
	rate->all_sum -= rate->value[XY]-val;
	rate->value[XY] = val;

	return;
}

// [g\
void showRate(Rate* rate){
	Coordinate2d i, j, k;
	Coordinate1d XY;
	
	char charset[] = {'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T'};
	char put[2];
	k=DEFAULT_BANSIZE;

	fprintf(stderr, "#  ");
	for(j=0; j<DEFAULT_BANSIZE; j++){
		put[0] = charset[j];
		put[1] = '\0';
		fprintf(stderr, "  %s ",put);
	}
	fprintf(stderr, "\n");
	for (i=1; i<=DEFAULT_BANSIZE; i++){
		for (j=0; j<=DEFAULT_BANSIZE; j++){
			XY=getXY(j, i);
			if(isOOB(XY)){
				if(j==0){
					fprintf(stderr, "#%2d",k);
					k--;
				}
			}
			else if (rate->value[XY] == 0.0){
				fprintf (stderr, "  - ");
			}
			else{
				fprintf (stderr, "%3d ", rate->value[XY]);
			}
		}
//		fprintf (stderr, "%d", rate->col_sum[i+OOBLNUM-1]); // sv
		fprintf (stderr, "\n");
	}

//	fprintf (stderr, "#all_sum:%d\n", rate->all_sum); // v
	fflush(stderr);
}
